DECLARE SUB Datainput (zlz!, spz!, fa$, tm!())
DECLARE SUB GLEIJAC (vz, ma#(), mn#(), hkoe#(), vey#(), veyn#(), loealt#(), loeneu#(),loeinter#())
DECLARE SUB Matrixparameters (mul#, regnum!, resz, zlz!, spz!, pfadein$, pfadaus$, pnameein$, pnameaus$, faein$, faaus$)
REM *******************************************************
REM Multiple lineare Regression, Signifikanz und Konfidenzintervalle mittels Bootstrap
REM **** Name: MUBOQB.BAS Vers. 22.7.2015
REM *** der source code wurde kompatibel fuer QBasic und QB64 geschrieben !
REM **********************************************************************
	CLS
	PRINT "           Bootstrap estimation"
	PRINT "                  of "
	PRINT "  multiple regression parameters"
	PRINT "  by random bootstrap algorithm.": PRINT : PRINT
PRINT "(Copyright Hans L. Nemeschkal, Vienna 2015 - "
PRINT " Department of Theoretical Biology, University of Vienna,"
PRINT " Althanstrasse 14, A-1090 Wien, Austria)"
PRINT
REM ********* matrixparameters **************
CALL Matrixparameters(mul#, regnum!, resz, zlz!, spz!, pfadein$, pfadaus$, pnameein$, pnameaus$, faein$, faaus$)

OPEN faaus$ FOR OUTPUT AS #2
PRINT #2, "date: "; DATE$; " time: "; TIME$: PRINT #2, " "
	PRINT #2, "           Bootstrap estimation"
	PRINT #2, "                  of "
	PRINT #2, "  multiple regression parameters"
	PRINT #2, "  by random bootstrap algorithm.": PRINT #2,""
PRINT #2, "Program name: MUBOQB.BAS, vers. 22.07.2015." :PRINT #2,""
PRINT #2, "(Copyright Hans L. Nemeschkal, Vienna 2015 - "
PRINT #2, " Department of Theoretical Biology, University of Vienna,"
PRINT #2, " Althanstrasse 14, A-1090 Wien, Austria)"
PRINT #2, ""
PRINT #2, "name of the input data file: "; pnameein$
PRINT #2, "number of rows: "; zlz!
PRINT #2, "number of columns: "; spz!
PRINT #2, "*******************************************************"
PRINT #2, "the original data (input data):"

REM ************************ defining the dimensions of arrays *************************
DIM tm!(zlz!, spz!),botm!(zlz!, spz!): REM raw datamatrix and bootstrap resampling matrix
DIM yr!(zlz!): REM storage der Kriteriumwerte
DIM obfit!(zlz!),obres!(zlz!): REM storage der fitted und residual values der beobachteten Werte
REM number of parameter values being registrated
DIM parastoreobs# (spz!), parastore#(regnum!, spz!): REM resulting parameter values: Werte fuer das beobachtete Sample u. Werte fuer die Bootstrap-Resamples
DIM BEboot#(regnum!) :REM multiples Bestimmtheitsmass, bootstrap
vz = spz!:REM Anzahl der Praediktoren - Vorbereitung der JACOBI-Iteration zur Loesung des Regressionsgleichungssystems
DIM ma#(vz, vz), mn#(vz, vz), hkoe#(vz), vey#(vz), veyn#(vz), loealt#(vz), loeneu#(vz), loeinter#(vz)
DIM avparave#(spz!), varparave#(spz!), sigve#(spz!), nullwe#(spz!)
REM Rohdaten einladen 
DIM pi95lo!(zlz!),pi95up!(zlz!),pi99lo!(zlz!),pi99up!(zlz!)
REM unteres und oberes 95%-Konfidenzintervall, d.h. confidence intervals for the mean of the estimator of Y (criterion), sowie
REM unteres und oberes 99%-Konfidenzintervall, d.h. confidence intervals for the mean of the estimator of Y (criterion).
DIM siob95lo!(zlz!),siob95up!(zlz!),siob99lo!(zlz!),siob99up!(zlz!), siobabs95(zlz!), siobabs99(zlz!)
REM prediction intervals for single observations, i.d. single estimations of Y.
REM ************************ end of defining the dimensions of arrays *************************

REM ********* input of the observed data **********************************************************
CALL Datainput((zlz!), (spz!), (faein$), tm!())
FOR zl = 1 TO zlz!
 FOR sp = 1 TO spz!
  PRINT #2, tm!(zl, sp),
  PRINT tm!(zl, sp),
 NEXT sp
 PRINT #2, ""
 NEXT zl
 PRINT #2, ""
PRINT #2, "*******************************************************"
REM ********* end of input of the observed data ****************************************************

REM ***** zur Initialisierung des RND noetiger Umbau der TIMER-Werte
orig# = TIMER
REM ***** direkter TIMER-Aufruf
RANDOMIZE orig#
REM ********


REM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% observed data calculations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
REM Umschichtung fuer die erste Berechnung, d.h. Berechnung mit den beobachteten Werten
FOR zl = 1 TO zlz!
 FOR sp = 1 TO spz!
  botm!(zl, sp) = tm!(zl, sp)
 NEXT sp
NEXT zl

REM Umschichtung zur Vorbereitung der Berechnung des Normalgleichungssystems, Umschichtung-Kriterium
FOR zl = 1 to zlz!
    yr!(zl) = botm!(zl,1) :botm!(zl,1) = 1
    REM PRINT zl,yr!(zl),tm!(zl,1)
NEXT zl

REM +++++++++++++++++++++++++++++++++
REM Mittelwert und totale Streuung-Y
su# = 0 
FOR zl = 1 to zlz!
    su# = su# + yr!(zl)
NEXT zl
miy# = su#/zlz! :REM Mittelwert-Y
su# = 0 
FOR zl = 1 to zlz!
    su# = su# + (yr!(zl)- miy#) * (yr!(zl)- miy#)
NEXT zl
totAbw# = su# :REM totale Streuung-Y
REM +++++++++++++++++++++++++++++++++

REM Erstellen des Normalgleichungssystems *************+
FOR spuno = 1 TO spz!
  FOR spdue = 1 TO spz!
   su# = 0 :REM Initialisierung
   FOR zl = 1 TO zlz!
    su# = su# + botm!(zl,spuno)*botm!(zl,spdue)
   NEXT zl
    ma#(spuno,spdue) = su# :REM Eintrag in die Matrix der Normalgleichung- Koffizientenmatrix 
  NEXT spdue
   su# = 0 :REM Initialisierung
   FOR zl = 1 TO zlz!
    su# = su# + botm!(zl,spuno)*yr!(zl)
   NEXT zl
    vey#(spuno) = su# :REM Eintrag in die Matrix der Normalgleichung- Y-vektor   
NEXT spuno

CALL GLEIJAC (vz, ma#(), mn#(), hkoe#(), vey#(), veyn#(), loealt#(), loeneu#(),loeinter#())
PRINT "Loesungsvektor:"
FOR j = 0 TO (spz!- 1)
    REM Storage der Parameterwerte aus dem beobachteten Sample
    REM in parastoreobs#(0) liegt b0, dann aufsteigend b1, b2 ... etc.
    parastoreobs#(j) = loeneu#(j+1)
   PRINT parastoreobs#(j)
NEXT j

REM +++++++++++++++++++++++++++++++++
REM erklärte Streuung-Y
su# = 0 
FOR zl = 1 to zlz!
     ersu# = parastoreobs#(0)
     FOR j = 2 TO spz!
         ersu# = ersu# + parastoreobs#(j-1)*botm!(zl,j)
     NEXT j
     REM fitted values berechnen
     obfit!(zl) = ersu#
     REM residual values berechnen
     obres!(zl) = tm!(zl,1) - obfit!(zl)
     su# = su# + (ersu# - miy#)*(ersu# - miy#)
NEXT zl
erklAbw# = su# :REM erklaerte Streuung-Y, explained sum of squares
oberklAbw# = erklAbw#
resAbw# = totAbw# - erklAbw# :REM residuelle Streuung, unexplained sum of squares
obtotAbw# = totAbw#
obresAbw# = resAbw#
REM totAbw# ... total sum of squares

REM +++++++++++++++++++++++++++++++++
REM ++++++ multiples Bestimmheitsmass BEobs#
BEobs# = erklAbw#/totAbw#
REM +++++++++++++++++++++++++++++++++
PRINT erklAbw#,totAbw#, BEobs#
REM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% END - observed data calculations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


REM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% resamplings calculations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
REM ****************** BOOTSTRAP ************************************************************
PRINT 
FOR res = 1 to resz
PRINT res
    
     REM random bootstrap, resampling with replacement
     az = 1: ez = zlz!
     REM RANDOMIZE TIMER
    FOR zl = 1 TO zlz!
      zuf# = RND(1)
      ax = INT((ez - az + 1) * zuf# + az)
      REM Erzeugen d. Bootstrap-Resamples aus den beobachteten Werten, sampling with replacement
       FOR sp = 1 TO spz!
        botm!(zl, sp) = tm!(ax, sp)
       NEXT sp
    NEXT zl
 

REM Umschichtung zur Vorbereitung der Berechnung des Normalgleichungssystems, Umschichtung-Kriterium
FOR zl = 1 to zlz!
    yr!(zl) = botm!(zl,1) :botm!(zl,1) = 1
    REM PRINT zl,yr!(zl),tm!(zl,1) 
NEXT zl

REM +++++++++++++++++++++++++++++++++
REM Mittelwert und totale Streuung-Y
su# = 0 
FOR zl = 1 to zlz!
    su# = su# + yr!(zl)
NEXT zl
miy# = su#/zlz! :REM Mittelwert-Y
su# = 0 
FOR zl = 1 to zlz!
    su# = su# + (yr!(zl)- miy#) * (yr!(zl)- miy#)
NEXT zl
totAbw# = su# :REM totale Streuung-Y
REM +++++++++++++++++++++++++++++++++

REM Normalgleichunsgsystem (Bootstrap) erstellen
FOR spuno = 1 TO spz!
  FOR spdue = 1 TO spz!
   su# = 0 :REM Initialisierung
   FOR zl = 1 TO zlz!
    su# = su# + botm!(zl,spuno)*botm!(zl,spdue)
   NEXT zl
    ma#(spuno,spdue) = su# :REM Eintrag in die Matrix der Normalgleichung- Koffizientenmatrix 
  NEXT spdue
   su# = 0 :REM Initialisierung
   FOR zl = 1 TO zlz!
    su# = su# + botm!(zl,spuno)*yr!(zl)
   NEXT zl
    vey#(spuno) = su# :REM Eintrag in die Matrix der Normalgleichung- Y-vektor   
    
NEXT spuno
CALL GLEIJAC (vz, ma#(), mn#(), hkoe#(), vey#(), veyn#(), loealt#(), loeneu#(),loeinter#())
REM PRINT "Loesungsvektor:"
FOR j = 0 TO (spz!- 1)
    REM Storage der Parameterwerte aus dem Bootstrap-resample
    REM in parastore#(res,0) liegt b0, dann aufsteigend b1, b2 ... etc.
    parastore#(res,j) = loeneu#(j+1)
   
NEXT j

REM +++++++++++++++++++++++++++++++++
REM erklärte Streuung-Y
su# = 0 
FOR zl = 1 to zlz!
     ersu# = parastore#(res,0)
     FOR j = 2 TO spz!
        ersu# = ersu# + parastore#(res,j-1)*botm!(zl,j)
     NEXT j
    su# = su# + (ersu# - miy#)*(ersu# - miy#)
NEXT zl
erklAbw# = su# :REM erklaerte Streuung-Y
REM +++++++++++++++++++++++++++++++++
REM ++++++ multiples Bestimmheitsmass BEboot#()
BEboot#(res) = erklAbw#/totAbw#
REM +++++++++++++++++++++++++++++++++
PRINT erklAbw#,totAbw#, BEboot#(res)

NEXT res
PRINT "The end of bootstrap-resampling"
REM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% END of resamplings calculations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

REM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& 95%-confidence intervals for the mean of the estimator of Y (criterion) &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
REM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& 95%-prediction intervals for single observations, i.d. single estimations of Y &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
REM Initialisieren von pi95lo!() und pi95up!() von siob95lo!() und siob95up!()
FOR zl = 1 TO zlz!
  pi95lo!(zl) = 0 :pi95up!(zl) = 0 :siob95lo!(zl) = 0 :siob95up!(zl) = 0
NEXT zl
itpre = 5*5 :REM iterations for the calculations of the confidence and prediction intervals
za = 0 :mz = 0

FOR iti = 1 TO itpre
FOR zl = 1 TO zlz!
za = mz
za = za + 1 :IF za > regnum! THEN za = 1
prsu# = parastore#(za,0) 
	FOR j = 2 TO spz!
	  prsu# = prsu# + parastore#(za,j-1)*tm!(zl,j)
 	NEXT j
        resid# = tm!(zl,1) - prsu# :REM Residuum
REM Initialisierung von Niedrigst- und Hoechstwert
	nw# = prsu#: hw# = prsu#
        nwsiob# = resid#: hwsiob# = resid#

   FOR w = 1 to 40
     mz = mz + 1 :IF mz > regnum! THEN mz = 1
     prsu# = parastore#(mz,0)
	FOR j = 2 TO spz!
	  prsu# = prsu# + parastore#(mz,j-1)*tm!(zl,j)
	NEXT j
        resid# = tm!(zl,1) - prsu# :REM Residuum
    IF prsu# < nw# THEN nw# = prsu#
    IF prsu# > hw# THEN hw# = prsu#
    IF resid# < nwsiob# THEN nwsiob# = resid#
    IF resid# > hwsiob# THEN hwsiob# = resid#
   NEXT w
   pi95lo!(zl) = pi95lo!(zl) + nw# :pi95up!(zl) = pi95up!(zl) + hw#
   siob95lo!(zl) = siob95lo!(zl) + nwsiob# :siob95up!(zl) = siob95up!(zl) + hwsiob#
NEXT zl
NEXT iti
FOR zl = 1 TO zlz!
  REM average of 95%-confidence and prediction limits
  pi95lo!(zl) = pi95lo!(zl)/itpre :pi95up!(zl) = pi95up!(zl)/itpre
  siob95lo!(zl) = siob95lo!(zl)/itpre :siob95up!(zl) = siob95up!(zl)/itpre
NEXT zl

REM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& END of 95%-confidence intervals for the mean of the estimator of Y (criterion) &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
REM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& END of 95%-prediction intervals for single observations, i.d. single estimations of Y &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

REM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& 99%-confidence intervals for the mean of the estimator of Y (criterion) &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
REM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& 99%-prediction intervals for single observations, i.d. single estimations of Y &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
REM Initialisieren von pi99lo!() und pi99up!() von siob99lo!() und siob99up!()
FOR zl = 1 TO zlz!
  pi99lo!(zl) = 0 :pi99up!(zl) = 0 :siob99lo!(zl) = 0 :siob99up!(zl) = 0
NEXT zl
itpre = 1*5 :REM iterations for the calculations of the confidence and prediction intervals
za = 0 :mz = 0

FOR iti = 1 TO itpre
FOR zl = 1 TO zlz!
za = mz
za = za + 1 :IF za > regnum! THEN za = 1
prsu# = parastore#(za,0) 
	FOR j = 2 TO spz!
	  prsu# = prsu# + parastore#(za,j-1)*tm!(zl,j)
 	NEXT j
        resid# = tm!(zl,1) - prsu# :REM Residuum
REM Initialisierung von Niedrigst- und Hoechstwert
	nw# = prsu#: hw# = prsu#
        nwsiob# = resid#: hwsiob# = resid#

   FOR w = 1 to 200
     mz = mz + 1 :IF mz > regnum! THEN mz = 1
     prsu# = parastore#(mz,0)
	FOR j = 2 TO spz!
	  prsu# = prsu# + parastore#(mz,j-1)*tm!(zl,j)
	NEXT j
        resid# = tm!(zl,1) - prsu# :REM Residuum
    IF prsu# < nw# THEN nw# = prsu#
    IF prsu# > hw# THEN hw# = prsu#
    IF resid# < nwsiob# THEN nwsiob# = resid#
    IF resid# > hwsiob# THEN hwsiob# = resid#
   NEXT w
   pi99lo!(zl) = pi99lo!(zl) + nw# :pi99up!(zl) = pi99up!(zl) + hw#
   siob99lo!(zl) = siob99lo!(zl) + nwsiob# :siob99up!(zl) = siob99up!(zl) + hwsiob#
NEXT zl
NEXT iti
FOR zl = 1 TO zlz!
  REM average of 99%-confidence and prediction limits
  pi99lo!(zl) = pi99lo!(zl)/itpre :pi99up!(zl) = pi99up!(zl)/itpre
  siob99lo!(zl) = siob99lo!(zl)/itpre :siob99up!(zl) = siob99up!(zl)/itpre
NEXT zl

REM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& END of 99%-confidence intervals for the mean of the estimator of Y (criterion) &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
REM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& END of 99%-prediction intervals for single observations, i.d. single estimations of Y &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

REM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& 95%-prediction intervals(absoluter Betrag) for single observations, i.d. single estimations of Y &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
REM &&&&&&&&&&& zur Erstellung symmetrischer Pediction-intervalle 
REM Initialisieren von siobabs95!()
FOR zl = 1 TO zlz!
  siobabs95!(zl) = 0
NEXT zl
itpre = 5*5 :REM iterations for the calculations of the confidence and prediction intervals
za = 0 :mz = 0

FOR iti = 1 TO itpre
FOR zl = 1 TO zlz!
za = mz
za = za + 1 :IF za > regnum! THEN za = 1
prsu# = parastore#(za,0) 
	FOR j = 2 TO spz!
	  prsu# = prsu# + parastore#(za,j-1)*tm!(zl,j)
 	NEXT j
        resid# = tm!(zl,1) - prsu# :REM Residuum
REM Initialisierung des Hoechstwert - Abs Betrag des Resdiuum
        hwsiobabs# = ABS(resid#)

   FOR w = 1 to 40
     mz = mz + 1 :IF mz > regnum! THEN mz = 1
     prsu# = parastore#(mz,0)
	FOR j = 2 TO spz!
	  prsu# = prsu# + parastore#(mz,j-1)*tm!(zl,j)
	NEXT j
        resid# = tm!(zl,1) - prsu# :REM Residuum
    IF ABS(resid#) > hwsiobabs# THEN hwsiobabs# = ABS(resid#)
   NEXT w
    siobabs95!(zl) = siobabs95!(zl) + hwsiobabs#
NEXT zl
NEXT iti
FOR zl = 1 TO zlz!
  REM average of 95%-prediction limits
  siobabs95!(zl) = siobabs95!(zl)/itpre
NEXT zl
REM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& END of 95%-prediction intervals(absoluter Betrag) for single observations, i.d. single estimations of Y &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&


REM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& 99%-prediction intervals(absoluter Betrag) for single observations, i.d. single estimations of Y &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
REM &&&&&&&&&&& zur Erstellung symmetrischer Pediction-intervalle 
REM Initialisieren von siobabs99!()
FOR zl = 1 TO zlz!
  siobabs99!(zl) = 0
NEXT zl
itpre = 1*5 :REM iterations for the calculations of the confidence and prediction intervals
za = 0 :mz = 0

FOR iti = 1 TO itpre
FOR zl = 1 TO zlz!
za = mz
za = za + 1 :IF za > regnum! THEN za = 1
prsu# = parastore#(za,0) 
	FOR j = 2 TO spz!
	  prsu# = prsu# + parastore#(za,j-1)*tm!(zl,j)
 	NEXT j
        resid# = tm!(zl,1) - prsu# :REM Residuum
REM Initialisierung des Hoechstwert - Abs Betrag des Resdiuum
        hwsiobabs# = ABS(resid#)

   FOR w = 1 to 200
     mz = mz + 1 :IF mz > regnum! THEN mz = 1
     prsu# = parastore#(mz,0)
	FOR j = 2 TO spz!
	  prsu# = prsu# + parastore#(mz,j-1)*tm!(zl,j)
	NEXT j
        resid# = tm!(zl,1) - prsu# :REM Residuum
    IF ABS(resid#) > hwsiobabs# THEN hwsiobabs# = ABS(resid#)
   NEXT w
    siobabs99!(zl) = siobabs99!(zl) + hwsiobabs#
NEXT zl
NEXT iti
FOR zl = 1 TO zlz!
  REM average of 95%-prediction limits
  siobabs99!(zl) = siobabs99!(zl)/itpre
NEXT zl
REM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& END of 95%-prediction intervals(absoluter Betrag) for single observations, i.d. single estimations of Y &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



REM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% OUTPUT, significances  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Delbend:
REM ##################### OUTPUT of the results ###################
PRINT #2, ""
PRINT #2, "****************** BOOTSTRAP ***************************"
PRINT #2, ""
PRINT #2, "total number of random bootstrap-resamplings:"; resz
PRINT #2, ""
PRINT #2, ""
REM ***** Ausdruck der in der random-bootstrap-Prozedur erzielten Werte, chronologische Ordnung
PRINT #2, ""
PRINT #2, "###################################################"
PRINT #2, "the observed data sample:"
PRINT #2, ""
PRINT #2, "coefficient of determination:"; BEobs#
PRINT #2, ""
PRINT #2, "parameter values of the regression model, i.e. b0; b1; b2 ....etc."
  	FOR sp = 0 TO (spz! - 1)
	 PRINT #2, parastoreobs#(sp); : PRINT #2, ";";
	NEXT sp
	PRINT #2, ""
PRINT #2, "##################################################"
PRINT #2, "total sum of squares:";obtotAbw#
PRINT #2, "explained sum of squares:";oberklAbw#
PRINT #2, "unexplained sum of squares:";obresAbw#
PRINT #2, "standard error of estimate:";SQR(obresAbw#/(zlz!-2)) :REM Standardschätzfehler
	PRINT #2, ""
PRINT #2, "##################################################"
PRINT #2, "fitted values of the model - observed data sample"
	PRINT #2, ""
FOR zl = 1 to zlz!
    PRINT #2, obfit!(zl)
NEXT zl
	PRINT #2, ""
PRINT #2, "##################################################"
PRINT #2, "residual values of the model - observed data sample"
	PRINT #2, ""
FOR zl = 1 to zlz!
    PRINT #2, obres!(zl)
NEXT zl
	PRINT #2, ""
PRINT #2, "##################################################"
PRINT #2, "results of random bootstrap:"
PRINT #2, ""
PRINT #2, "parameter values of the regression model, i.e. b0; b1; b2 ....etc."

zlend! = regnum!
FOR zl = 1 TO zlend!
  PRINT #2, zl; : PRINT #2, ";";
  	FOR sp = 0 TO (spz! - 1)
	 PRINT #2, parastore#(zl, sp); : PRINT #2, ";";
	NEXT sp
	PRINT #2, ""
NEXT zl
PRINT #2, "##################################################"
REM ##############################################################
REM averages and variances of the bootstrap-parameter-values
FOR sp = 0 TO spz!
	avparave#(sp) = 0
	varparave#(sp) = 0
NEXT sp

zlend! = regnum!
FOR zl = 1 TO zlend!
   FOR sp = 0 TO (spz! - 1)
	   avparave#(sp) = avparave#(sp) + parastore#(zl, sp)
	   varparave#(sp) = varparave#(sp) + parastore#(zl, sp) * parastore#(zl, sp)
   NEXT sp
NEXT zl
REM *** calculation of the variances of the parameters from the bootstrap distribution *******
FOR sp = 0 TO spz!
	var# = (varparave#(sp) - (avparave#(sp) * avparave#(sp) / zlend!)) / (zlend! - 1)
	varparave#(sp) = var#
NEXT sp
REM *** calculation of the averages of the parameters from the bootstrap distribution *******
FOR sp = 0 TO spz!
	avparave#(sp) = avparave#(sp) / zlend!
NEXT sp
REM average  bootstrap distribution-values
PRINT #2, ""
PRINT #2, "average bootstrap-parameter values:"
FOR sp = 0 TO (spz! - 1)
	PRINT #2, avparave#(sp);
NEXT sp
REM the standard error of  bootstrap distribution-values
PRINT #2, ""
PRINT #2, "standard error (= SE):"
PRINT #2, "SE of parameter values under bootstrap-conditions:"
FOR sp = 0 TO (spz! - 1)
	REM PRINT sp, varparave#(sp)
NEXT sp
FOR sp = 0 TO (spz! - 1)
	PRINT #2, SQR(varparave#(sp));
NEXT sp

REM +++++++++++++++++++++++++++++++++++++++
REM bias-reduced parameter values
PRINT #2, ""
PRINT #2, "***************************************"
PRINT #2, "bias-reduced parameter values:"
FOR sp = 0 TO (spz! - 1)
        biasred# = 2*parastoreobs#(sp) - avparave#(sp) 
	PRINT #2, biasred#;
NEXT sp
PRINT #2, ""
PRINT #2, "***************************************"


REM +++++++++++++++++++++++++++++++++++++++


REM zero-significance, two-sided p-values
   FOR sp = 0 TO (spz! - 1)
	  sigve#(sp) = 0 :nullwe#(sp) = 0
   NEXT sp
FOR zl = 1 TO zlend!
   FOR sp = 0 TO (spz! - 1)
	   IF parastore#(zl, sp) < 0 THEN sigve#(sp) = sigve#(sp) + 1
           IF parastore#(zl,sp) = 0 THEN nullwe#(sp) = nullwe#(sp) + 1
   NEXT sp
NEXT zl
PRINT #2, ""
PRINT #2, ""
PRINT #2, "##################################################"
PRINT #2, "Nullproportionen d. Parameter {ein- und zweiseitiger P-value}:"
   FOR sp = 0 TO (spz! - 1)
          kleiner# = sigve#(sp) :groess# = zlend! - (kleiner# + nullwe#(sp))
          REM kleiner# .... alle Werte <als Null, groess# ... alle Werte groesser als Null,nullwe#.... Anzahl der Werte '0'
          REM fuer die Ermittlung des P-values wird das kleineres Percentil gesucht, welches durch die '0'-Teilung der Bootstrap-Parameterverteilung entsteht
          REM also entweder kleiner# oder groess#. Das Gegenstück zu kleiner# ist immer (nullwe# + groess#) und das Gegenstück zu groess# ist immer (nullwe#+ kleiner#)

          IF kleiner# <= groess# THEN final# = kleiner# 
          IF kleiner# > groess# THEN final# = groess#
          irrwein# = final#/zlend! :REM 'einseitige Irrtmuswahrscheinlichkeit' 
          irrwzwei# = 2*irrwein# :REM 'zweiseitige Irrtumswahrscheinlchkeit'

          REM PRINT #2, "b";sp;":";(kleiner#/zlend!),(nullwe#(sp)/zlend!),(groess#/zlend!)
          PRINT #2, "b";sp;":";
          PRINT #2, "          P-value:   ";
          IF irrwein# > 0 THEN PRINT #2,irrwein#,irrwzwei#
          IF irrwein# = 0 THEN PRINT #2,"< ";(1/zlend!),"< ";(1/zlend!)
          PRINT #2, ""
          
   NEXT sp
PRINT #2, ""

REM ################### Bubblesort of paramater values ####################
PRINT #2, ""
PRINT #2, ""
PRINT #2, "##################################################"
PRINT "Bubblesort of the parameter values:"
FOR sp = 0 TO (spz!-1)
Bubble1:
mmz! = 0: REM initializing
  FOR j = 1 TO (zlend! - 1)
	IF parastore#(j, sp) > parastore#(j + 1, sp) THEN mmz! = mmz! + 1: vax# = parastore#(j + 1, sp): parastore#(j + 1, sp) = parastore#(j, sp): parastore#(j, sp) = vax#
  NEXT j
	IF mmz! > 0 THEN GOTO Bubble1
	GOTO Bubble2
Bubble2:
NEXT sp

REM ################### End of Bubblesort of paramater values ####################
PRINT #2, "Bubblesorted bootstrap-parameter- values:"
PRINT #2, ""
PRINT #2, "parameter values of the regression model, i.e. b0; b1; b2 ....etc."
FOR zl = 1 TO zlend!
 	FOR sp = 0 TO (spz! - 1)
	 PRINT #2, parastore#(zl, sp); : PRINT #2, ";";
	NEXT sp
	PRINT #2, ""
NEXT zl
PRINT #2, "##################################################"
PRINT #2, ""
PRINT #2, "##################################################"
PRINT #2, "lower 95%-confidence limits of parameter values:"
REM 95%-Konfidenzintervall der Parameterwerte
	FOR sp = 0 TO (spz! - 1)
        uw% = 0.025*zlend!
	UG95# = parastore#(uw%,sp)
	 PRINT #2, UG95#; : PRINT #2, ";";
	NEXT sp
PRINT #2,""
PRINT #2, "upper 95%-confidence limits of parameter values:"
	FOR sp = 0 TO (spz! - 1)
        ow% = 0.975*zlend! 
	OG95# = parastore#(ow%,sp)
	 PRINT #2, OG95#; : PRINT #2, ";";
	NEXT sp
REM ++++++++++++++++++++++++++++++++++++++++++++++
PRINT #2, ""

REM +++++++++++++++++++++++++ confidence and prediction intervals +++++++++++++++++++++++++++++++++++


PRINT #2, ""
PRINT #2, ""
PRINT #2, "########## bootstrapped CONFIDENCE INTERVALS for the observed individuals #######################################"
PRINT #2, ""
PRINT #2, "##################################################"
PRINT #2, "95% - confidence intervals for the mean of the estimator of Y (criterion):"
PRINT #2, "95% - lower limits for";zlz!;" individuals:"
FOR zl = 1 TO zlz!
    PRINT #2,pi95lo!(zl)
NEXT zl
PRINT #2, ""
PRINT #2, "95% - upper limits for";zlz!;" individuals:"
FOR zl = 1 TO zlz!
    PRINT #2,pi95up!(zl)
NEXT zl
PRINT #2, ""
PRINT #2, ""
PRINT #2, "##################################################"
PRINT #2, "99% - confidence intervals for the mean of the estimator of Y (criterion):"
PRINT #2, "99% - lower limits for";zlz!;" individuals:"
FOR zl = 1 TO zlz!
    PRINT #2,pi99lo!(zl)
NEXT zl
PRINT #2, ""
PRINT #2, "99% - upper limits for";zlz!;" individuals:"
FOR zl = 1 TO zlz!
    PRINT #2,pi99up!(zl)
NEXT zl
PRINT #2, ""
PRINT #2, ""
PRINT #2, ""
PRINT #2, "########## bootstrapped PREDICTION INTERVALS for single observations, i.d. single estimations of Y #######################################"
PRINT #2, ""
PRINT #2, "##################################################"
PRINT #2, "95% - prediction intervals for for single observations:"
PRINT #2, "95% - lower limits for";zlz!;" individuals:"
FOR zl = 1 TO zlz!
    PRINT #2,siob95lo!(zl)
NEXT zl
PRINT #2, ""
PRINT #2, "95% - upper limits for";zlz!;" individuals:"
FOR zl = 1 TO zlz!
    PRINT #2,siob95up!(zl)
NEXT zl
PRINT #2, ""
PRINT #2, ""
PRINT #2, "##################################################"
PRINT #2, "99% - prediction intervals for for single observations:"
PRINT #2, "99% - lower limits for";zlz!;" individuals:"
FOR zl = 1 TO zlz!
    PRINT #2,siob99lo!(zl)
NEXT zl
PRINT #2, ""
PRINT #2, "99% - upper limits for";zlz!;" individuals:"
FOR zl = 1 TO zlz!
    PRINT #2,siob99up!(zl)
NEXT zl
PRINT #2, ""
PRINT #2, ""
PRINT #2, ""
PRINT #2, ""
PRINT #2, "########## bootstrapped PREDICTION INTERVALS for single observations, i.d. single estimations of Y  - symmetric intervals#######################################"
PRINT #2, ""
PRINT #2, "##################################################"
PRINT #2, "95% - prediction intervals for for single observations:"
PRINT #2, "one half of the symmetric interval-length for";zlz!;" individuals:"
FOR zl = 1 TO zlz!
    PRINT #2,siobabs95!(zl)
NEXT zl
PRINT #2, ""
PRINT #2, ""
PRINT #2, "##################################################"
PRINT #2, "99% - prediction intervals for for single observations:"
PRINT #2, "one half of the symmetric interval-length for";zlz!;" individuals:"
FOR zl = 1 TO zlz!
    PRINT #2,siobabs99!(zl)
NEXT zl
PRINT #2, ""
PRINT #2, ""
PRINT #2, "##################### END #############################"
REM +++++++++++++++++++++++++ END of confidence and prediction intervals +++++++++++++++++++++++++++

PRINT "Ende"
CLOSE #2
REM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% END of OUTPUT, significances  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

END


REM ================================== Subroutines =====================================================================================================


SUB GLEIJAC (vz, ma#(), mn#(), hkoe#(), vey#(), veyn#(), loealt#(), loeneu#(), loeinter#()) STATIC
REM ********* Iterative Loesung eines linearen Gleichungssystems - JACOBI-Verfahren 
REM die Koeffizientenmatrix A wird in der Matrix ma#(vz,vz) uebergeben, Dimension der Matrix ist vz
REM der Y-Vektor wird in vey#(vz) uebergeben
REM der Loesungsvektor wird als Output mit loeneu#(vz) uebergeben
REM die Hauptroutine ist zu finden unter ...
REM *****************************************************
REM ***  alter Name: GleiJACOBI, Vers. 11.7.1993
REM +++ dann alter Name gleijac.bas
REM ****  neuer Name: GLJACQB.BAS Vers. 9.2.2015
REM *** Loesung eines linearen Gleichungssystems
REM *** mit n Unbekannten mittels JACOBI-Iteration
REM *** Verfeinerung zu Einzeschlschrittverfahren: GAUSS-SEIDEL-Verfahren (GS)
REM *** mit dem Vorteil, dass das GS im Falle einer symmetrischen postiv definiten Matrix stets konvergiert !
REM *** Die zu erwartenden Normalgleichgungssystem haben alle diesen Matrizentyp zugrunde liegen!
REM *****************************************************

Menueanfang:
REM *************************
REM erste Werte fuer
REM Komponennten d. Loesungsvektors zum Start willkuerlich mit `0` annehmen
FOR sp = 1 TO vz
    loealt#(sp) = 0
NEXT sp

REM Beginn der Iteration
Metneu1:
REM Initialisieren des Loesungsvektors-neu loeneu#()
FOR sp = 1 TO vz
    loeneu#(sp) = 0
NEXT sp
REM Auffuellen d. Zwischen-Loesungsvektors loeinter#() mit loealt#()
FOR sp = 1 TO vz
    loeinter#(sp) = loealt#(sp)
NEXT sp

REM eigentliches Iterationsverfahren
FOR zl = 1 TO vz
  loeneu#(zl) = loeneu#(zl) + vey#(zl)
  FOR sp = 1 TO vz
    IF sp <> zl THEN loeneu#(zl) = loeneu#(zl) -ma#(zl,sp)*loealt#(sp)
  NEXT sp
  loeneu#(zl) = loeneu#(zl)/ma#(zl,zl)
  REM PRINT zl,loeneu#(zl) 
  REM Einzelschrifftverfahren: Gauss-Seidel Verfeinerung
  loealt#(zl) = loeneu#(zl)
NEXT zl

zeiger = 0
FOR zl = 1 TO vz
   REM Abbruchkriterium abfragen
   IF ABS(loeneu#(zl) - loeinter#(zl)) > .00000001# THEN zeiger = 1
NEXT zl
Metneu2:
IF zeiger = 0 THEN GOTO Metitaende
REM Umschichtungen fuer die JACOBI-Methode
REM FOR zl = 1 TO vz
  REM loealt#(zl) = loeneu#(zl)
REM NEXT zl
GOTO Metneu1: REM Wiederholung

Metitaende:
END SUB

REM #############################################
SUB Matrixparameters (mul#, regnum!, resz, zlz!, spz!, pfadein$, pfadaus$, pnameein$, pnameaus$, faein$, faaus$) STATIC
REM ******************************************
REM zlz!...number of data rows(= number of OTUs)
REM spz!...number of data columns(= number of variables)
REM pfadein$... filepath, data input
REM pfadaus$...filepath, data output = output of results
REM pnameein$....name of datafile -input, pnameaus$...name of datafile-output
REM faein$....pfadein$+pnameein$, faaus$....pfadaus$+pnameaus$
REM ******************************************
Eingeber1:
PRINT
INPUT "full filepath of the input datafile :"; pfadein$: PRINT
INPUT "name of the input datafile:"; pnameein$: PRINT
PRINT "(Note please that Your input data file has to be an ASCII-file containing"
PRINT " the data in the following order:"
PRINT " (1) the cases per rows and the variables per columns,"
PRINT " (2) the citerion variable in the outermost left column"
PRINT "     and the predictor variables in the immediately following columns,"
PRINT " (3) avoid German `Komma`)"
PRINT
INPUT "number of rows in the input datafile:"; zlz!: PRINT
PRINT "number of columns (criterion plus all the predictor variables) "
INPUT "in the input datafile:"; spz!: PRINT
faein$ = pfadein$ + pnameein$
Ausgeber1:
CLS : PRINT
PRINT "(The results of the analysis will be stored in an ASCII outputfile)"
PRINT
INPUT "full filepath of the outputfile:"; pfadaus$: PRINT
INPUT "name of the outputfile:"; pnameaus$: PRINT
faaus$ = pfadaus$ + pnameaus$
CLS : PRINT
PRINT "Bootstrap values -"
PRINT
INPUT "number of random resamples:"; resz
PRINT
regnum! = resz :REM Anzahl der gestorten resamplings

END SUB

REM #############################################
SUB Datainput (zlz!, spz!, fa$, tm!()) STATIC
OPEN fa$ FOR INPUT AS #1
	 FOR zl = 1 TO zlz!: PRINT
	   FOR sp = 1 TO spz!
	 REM WHILE NOT EOF(1)
	 INPUT #1, a!
	 tm!(zl, sp) = a!: REM PRINT zl; sp; tm!(zl, sp),
	 REM WEND
	   NEXT sp
	 NEXT zl
CLOSE #1
END SUB
REM ================================== END of Subroutines =====================================================================================================
